#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <time.h>

#include "amcc.h"

void ctrl_data_integrity( );
void init_timer();
void ctrl_fill_memory( );
int  ctrl_validate_memory( );
void ctrl_tf_test();
void isamem_short_test();
void read_pio();
void write_pio();
void validate_addon_incoming_mailbox();
void write_addon_outgoing_mailbox();
void ctrl_ramp_test( );

int main()
{
char read_c_val;
int seed;
int test_number;

/* ------------------------------------------------- */
/* general purpose variables, used for register test */
/* ------------------------------------------------- */

int i, j;           /* 2 bytes */
long ilong;

int fail;
int pass;
char key;

/* --------------------------------------- */
/*  use these variables for counter tests  */
/* --------------------------------------- */

char cntr0_status, cntr1_status, cntr2_status;
char cntr_LSbyte, cntr_MSbyte;

unsigned cntr0_this_val, cntr0_prev_val;
unsigned cntr1_this_val, cntr1_prev_val;
unsigned cntr2_this_val, cntr2_prev_val;

/* file access */

FILE *stream;
char file_cc = 'C';
float file_ff = 1.234;

test_number = 1;

while (test_number != 0) {
  switch (test_number) {
    case 1:
	 /* ------ */
	 /*  Menu  */
	 /* ------ */
		printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
		printf(" 0 Exit\n");
		printf(" 1 Menu\n");
		printf(" 2 Memory(ISA) Walking 1's and 0's\n");
		printf(" 3 Write / Validate Memory(ISA) Test\n");
		printf(" 4 Full Memory(ISA) Test\n");
		printf(" 5 Memory(ISA) Loop\n");
		printf(" 6 Reserved\n");
		printf(" 7 Initialize Timer\n");
		printf(" 8 Read  PIO\n");
		printf(" 9 Write PIO\n");
		printf("10 Validate AIMB1 .. AIMB4\n");
		printf("11 Write AOMB1 .. AOMB4\n");
		printf("12 Validate Memory(ISA)\n");
		printf("13 Validate Full Memory(ISA)\n");
		printf("14 Write Memory(ISA)\n");
		printf("15 Write Full Memory(ISA)\n");
		printf("16 Data Integrity Using Mailbox\n");
		printf("17 Data Integrity Using Memory Location\n");
		printf("18 Data Integrity (TF) Using Mailbox\n");
		printf("19 Data Integrity (TF) Using Memory Location\n");
		printf("20 Ramp Test\n");

		printf("\nEnter test number to run >");
		scanf("%d",&test_number);
		scanf("%c",&key);
	break;

	case 2:
		isamem_low_walking_bit_test( );
		isamem_high_walking_bit_test( );
		test_number = 1;
    break;

    case 3:
  		printf("Write / Validate Memory(ISA) Test\n");
		isamem_short_test();
		test_number = 1;
    break;

  	case 4:
		seed = 1;
		ctrl_fill_memory(seed);

		if ( fail = ctrl_validate_memory(seed) )
	 		printf ("test fails, number of failures = %d\n", fail);
		 else
	 		printf ("test passes\n");

		printf("type any key to continue\n");
  		 scanf("%c",&key);

		test_number = 1;
    break;

    case 5:
		isamem_endless_loop();
		test_number = 1;
    break;

    case 6:
  		printf("Reserved\n");
		test_number = 1;
    break;

    case 7:
		init_timer();
		test_number = 1;
    break;

    case 8:
  		printf("Read PIO\n");
		read_pio();
		test_number = 1;
    break;

    case 9:
  		printf("Write PIO\n");
		write_pio();
		test_number = 1;
    break;

    case 10:
		printf("Validate AIMB1 .. AIMB4\n");
		validate_addon_incoming_mailbox();
		test_number = 1;
    break;

    case 11:
		printf("Write AOMB1 .. AOMB4\n");
		write_addon_outgoing_mailbox();
		test_number = 1;
    break;

    case 12:
		printf("Validate Memory(ISA), not implemented\n");
		printf("type any key to continue\n");
  		scanf("%c",&key);
		test_number = 1;
    break;

    case 13:
		printf("Validate Full Memory(ISA), not implemented\n");
		printf("type any key to continue\n");
  		scanf("%c",&key);
		test_number = 1;
    break;

    case 14:
		printf("Write Memory(ISA), not implemented\n");
		printf("type any key to continue\n");
  		scanf("%c",&key);
		test_number = 1;
    break;

    case 15:
		printf("Write Full Memory(ISA), not implemented\n");
		printf("type any key to continue\n");
  		scanf("%c",&key);
		test_number = 1;
    break;

	case 16:
		ctrl_data_integrity();
		test_number = 1;
    break;

	case 17:
		ctrl_data_integrity_mem();
		test_number = 1;
    break;

  	case 18:
		ctrl_tf_test();
		test_number = 1;
    break;

  	case 19:
		ctrl_tfmb_test();
		test_number = 1;
    break;

  	case 20:
		ctrl_ramp_test();
		test_number = 1;
    break;

  	case 22:
		printf("case 12\n");
		ctrl_read_mailbox_loop();
		test_number = 1;
    break;

    }  /* switch */

}  /* while */


}


